package nl.ontwik.services;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import nl.ontwik.model.Book;

/**
 * Unit test for simple App.
 */
public class AmazonBookAdapterTest
        extends TestCase {

    /**
     * Create the test case
     *
     * @param testName name of the test case
     */
    public AmazonBookAdapterTest(String testName) {
        super(testName);
    }

    /**
     * @return the suite of tests being tested
     */
    public static Test suite() {
        return new TestSuite(AmazonBookAdapterTest.class);
    }

    /**
     * Rigourous Test :-)
     */
    public void testFindBookByISBN() {
        AmazonBookAdapter bookService = new AmazonBookAdapter();

        Book book = null;

        book = bookService.findByISBN("0131738860");

        assertEquals("0131738860", book.getIsbn());
        assertTrue(book.getTitle().startsWith("Core JavaServer"));
        assertEquals(2, book.getAuthors().size());
        System.out.println(book.toString());
        assertNotNull(book.getDescription());
    }

    /**
     * Rigourous Test :-)
     */
    public void testFindBookByISBN_false() {
        AmazonBookAdapter bookService = new AmazonBookAdapter();

        Book book = null;

        book = bookService.findByISBN("0131738860");
        assertFalse("0131738861".equals(book.getIsbn()));
    }
}
